-- targetbutton
declare('targetbutton', targetbutton or {})
--TODO:  add option to ignore bots

targetbutton.version = 1.1

targetbutton.maincolor = "\127FFFFFF"
targetbutton.truecolor = "\12700FF00"
targetbutton.falsecolor = "\127FF0000"

--Lua is retarded and doesn't treat 0 as false, and gkini doesn't come with a WriteBool/ReadBool, so let's just roll our own.
function targetbutton.ReadBool(namespace, attribute, default)
	local d
	if default then d = 1 else d = 0 end
	return ( gkini.ReadInt(namespace, attribute, d) ~= 0 )
end
function targetbutton.WriteBool(namespace, attribute, value)
	local v
	if value then v = 1 else v = 0 end
	gkini.WriteInt(namespace, attribute, v)
end

--By default we want to kill everybody except group members
targetbutton.aggro = targetbutton.ReadBool('TargetButton', 'aggro', true)
targetbutton.ignore_groupies = targetbutton.ReadBool('TargetButton', 'group', true)
targetbutton.ignore_guildies = targetbutton.ReadBool('TargetButton', 'guild', false)

--Print booleans in color
function targetbutton.colorprint(val)
	if val then
		return(targetbutton.truecolor.."TRUE"..'\127o')
	else
		return(targetbutton.falsecolor.."FALSE"..'\127o')
	end
end

--Target the nearest person we want to kill
function targetbutton.target_nearest_enemy()
	local nearest_enemy = nil
	local nearest_enemy_distance = nil
	--Locate the closest suitable target
	ForEachPlayer(function (id)
		--don't target yourself
		if id ~= GetCharacterIDByName(GetPlayerName()) then
			--don't target groupies (optional)
			if not IsGroupMember(id) or not targetbutton.ignore_groupies then
				--don't target guildmates (optional)
				if not IsGuildMember(id) or not targetbutton.ignore_guildies then
					--don't target friendlies (optional)
					--if IsEnemy(id) or targetbutton.aggro then
					if GetFriendlyStatus(id)~=3 or targetbutton.aggro then
						--check if they're closer than the last one
						if nearest_enemy_distance == nil or (GetPlayerDistance(id) ~= nil and GetPlayerDistance(id) < nearest_enemy_distance) then
							nearest_enemy = id
							nearest_enemy_distance = GetPlayerDistance(id)
						end
					end
				end
			end
		end
	end
	)
	--Target them
	if nearest_enemy ~= nil then
		radar.SetRadarSelection(GetPlayerNodeID(nearest_enemy), GetPrimaryShipIDOfPlayer(nearest_enemy))
	end
end

--Process commands
function targetbutton.cmd(_,data)
	if data == nil then
		targetbutton.target_nearest_enemy()
	elseif data[1] == "aggro" then
		targetbutton.aggro = not targetbutton.aggro
		targetbutton.WriteBool('TargetButton', 'aggro', targetbutton.aggro)
		print(targetbutton.maincolor.."kill 'em all: \127o"..targetbutton.colorprint(targetbutton.aggro))
	elseif data[1] == "group" then
		targetbutton.ignore_groupies = not targetbutton.ignore_groupies
		targetbutton.WriteBool('TargetButton', 'group', targetbutton.ignore_groupies)
		print(targetbutton.maincolor.."ignore group: \127o"..targetbutton.colorprint(targetbutton.ignore_groupies))
	elseif data[1] == "guild" then
		targetbutton.ignore_guildies = not targetbutton.ignore_guildies
		targetbutton.WriteBool('TargetButton', 'guild', targetbutton.ignore_guildies)
		print(targetbutton.maincolor.."ignore guild: \127o"..targetbutton.colorprint(targetbutton.ignore_guildies))
	elseif data[1] == "print" then
		print(targetbutton.maincolor.."kill 'em all: \127o"..targetbutton.colorprint(targetbutton.aggro))
		print(targetbutton.maincolor.."ignore group: \127o"..targetbutton.colorprint(targetbutton.ignore_groupies))
		print(targetbutton.maincolor.."ignore guild: \127o"..targetbutton.colorprint(targetbutton.ignore_guildies))
	else
		print(targetbutton.maincolor.."/targetbutton [aggro|group|guild|print]\127o")
	end
end
RegisterUserCommand("targetbutton",targetbutton.cmd)
